///
/// @file	INA219_library.h
/// @brief	Class library header
/// @details	Library for INA219
/// @n
/// @n @b	Project INA219_main
/// @n @a	Developed with [embedXcode](http://embedXcode.weebly.com)
///
/// @author	Rei VILO
/// @author	embedXcode.weebly.com
/// @date	Jun 06, 2013
/// @version	203
///
/// @copyright	© Rei VILO, 2013
/// @copyright	CC = BY NC SA
/// http://creativecommons.org/licenses/by-nc-sa/3.0/
///
/// @n  You are free:
/// * to Share — to copy, distribute and transmit the work
/// * to Remix — to adapt the work
///
/// @n  Under the following conditions:
/// *   Attribution — You must attribute the work in the manner specified by the author or licensor (but not in any way that suggests that they endorse you or your use of the work).
/// *   Noncommercial — You may not use this work for commercial purposes.
// Core library - IDE-based
#if defined(MPIDE) // chipKIT specific
#include "WProgram.h"
#elif defined(DIGISPARK) // Digispark specific
#include "Arduino.h"
#elif defined(ENERGIA) // LaunchPad, FraunchPad and StellarPad specific
#include "Energia.h"
#elif defined(MAPLE_IDE) // Maple specific
#include "WProgram.h"
#elif defined(CORE_TEENSY) // Teensy specific
#include "WProgram.h"
#elif defined(WIRING) // Wiring specific
#include "Wiring.h"
#elif defined(ARDUINO) && (ARDUINO >= 100) // Arduino 1.0x and 1.5x specific
#include "Arduino.h"
#elif defined(ARDUINO) && (ARDUINO < 100)  // Arduino 23 specific
#include "WProgram.h"
#endif // end IDE
#ifndef INA219_LIBRARY_RELEASE
#define INA219_LIBRARY_RELEASE 203
#include "Wire.h"
class INA219 {
public:
    INA219();
    void begin();
    String WhoAmI();
    void get();
    uint32_t mV();
    uint32_t mA();
    uint32_t mW();
    bool overflow();
    bool ready();
private:
    uint32_t _shunt_mV, _bus_mV, _power_mW, _current_mA;
    bool _overflow, _ready;
    void _writeRegister(uint8_t reg, uint16_t data);
    uint16_t _readRegister(uint8_t reg);
};
#endif
